#include "stdifm.h"
#include "[!output MODULE_DISPLAY_NAME].h"

IfmModule g_pMod;  /* Global handle related to this plugin */

#pragma region IFM_Definitions
/* --- IFMREG_BEGIN --- */
/*  -- Do not edit! --  */

[!if CallBack_ExceptionHandler]
static void ExceptionHandler (IfmHandle, IfmExceptionContext*);
[!endif]
[!if CallBack_OnInitModule]
static IfmResult OnInitModule (IfmHandle);
[!endif]
[!if CallBack_OnExitModule]
static void OnExitModule (IfmHandle);
[!endif]
[!if CallBack_OnBeginDocument]
static IfmResult OnBeginDocument (IfmDocument);
[!endif]
[!if CallBack_OnEndDocument]
static void OnEndDocument (IfmDocument);
[!endif]
[!if CallBack_Serialize]
static void Serialize (IfmDocument, IfmArchive);
[!endif]
[!if CallBack_OnActivate]
static void OnActivate (IfmDocument, Widget);
[!endif]
[!if CallBack_OnEditDocument]
static void OnEditDocument (IfmDocument, Widget);
[!endif]
[!if CallBack_OnEnterSimulator]
static void OnEnterSimulator (IfmDocument);
[!endif]
[!if CallBack_OnLeaveSimulator]
static void OnLeaveSimulator (IfmDocument);
[!endif]
[!if CallBack_OnEnterProblemEditor]
static void OnEnterProblemEditor (IfmDocument);
[!endif]
[!if CallBack_OnLeaveProblemEditor]
static void OnLeaveProblemEditor (IfmDocument);
[!endif]
[!if CallBack_PreSimulation]
static void PreSimulation (IfmDocument);
[!endif]
[!if CallBack_PostSimulation]
static void PostSimulation (IfmDocument);
[!endif]
[!if CallBack_PreTimeStep]
static void PreTimeStep (IfmDocument);
[!endif]
[!if CallBack_PostTimeStep]
static void PostTimeStep (IfmDocument);
[!endif]
[!if CallBack_PreFlowSimulation]
static void PreFlowSimulation (IfmDocument);
[!endif]
[!if CallBack_PostFlowSimulation]
static void PostFlowSimulation (IfmDocument);
[!endif]
[!if CallBack_PreMassSimulation]
static void PreMassSimulation (IfmDocument, int);
[!endif]
[!if CallBack_PostMassSimulation]
static void PostMassSimulation (IfmDocument, int);
[!endif]
[!if CallBack_PreHeatSimulation]
static void PreHeatSimulation (IfmDocument);
[!endif]
[!if CallBack_PostHeatSimulation]
static void PostHeatSimulation (IfmDocument);
[!endif]
[!if CallBack_OnTimeStepConstraint]
static IfmBool OnTimeStepConstraint (IfmDocument, double, double*);
[!endif]
[!if CallBack_PostLoadDocument]
static void PostLoadDocument (IfmDocument pDoc);
[!endif]
[!if CallBack_PreSaveDocument]
static void PreSaveDocument (IfmDocument pDoc);
[!endif]
[!if CallBack_PostSaveDocument]
static void PostSaveDocument (IfmDocument pDoc);
[!endif]
[!if CallBack_OnChangeProblemClass]
static IfmResult OnChangeProblemClass (IfmDocument);
[!endif]
[!if CallBack_OnChangeTopology]
static void OnChangeTopology (IfmDocument);
[!endif]
[!if CallBack_OnLockPowerID]
static IfmBool OnLockPowerID (IfmDocument, int);
[!endif]
[!if CallBack_PreRefineProblem]
static IfmResult PreRefineProblem (IfmDocument, int, int);
[!endif]
[!if CallBack_PostRefineProblem]
static void PostRefineProblem (IfmDocument, IfmBool);
[!endif]
[!if CallBack_OnMarkElementsForAMR]
static void OnMarkElementsForAMR (IfmDocument);
[!endif]
[!if CallBack_OnRefineElementAttributes]
static void OnRefineElementAttributes (IfmDocument, int, int*, int, int*);
[!endif]
[!if CallBack_OnRefineNodeAttributes]
static void OnRefineNodeAttributes (IfmDocument, int, int, int);
[!endif]
[!if CallBack_OnStateChanged]
static void OnStateChanged (IfmDocument, IfmDOC_STATE);
[!endif]
[!if CallBack_OnStateChanging]
static IfmBool OnStateChanging (IfmDocument, IfmDOC_STATE);
[!endif]

/*
 * Enter a short description between the quotation marks in the following lines:
 */
static const char szDesc[] = 
  "[!output MODULE_DESCRIPTION]";

#ifdef __cplusplus
extern "C"
#endif /* __cplusplus */

IfmResult RegisterModule(IfmModule pMod)
{
  if (IfmGetFeflowVersion (pMod) < IFM_REQUIRED_VERSION)
    return False;
  g_pMod = pMod;
  IfmRegisterModule (pMod, "SIMULATION", "[!output MODULE_NAME]", "[!output MODULE_DISPLAY_NAME]", 0x1000);
  IfmSetDescriptionString (pMod, szDesc);
  IfmSetCopyrightPath (pMod, "[!output MODULE_DISPLAY_NAME].txt");
  IfmSetHtmlPage (pMod, "[!output MODULE_DISPLAY_NAME].htm");
  IfmSetPrimarySource (pMod, "[!output MODULE_DISPLAY_NAME].cpp");
[!if CallBack_ExceptionHandler]
  IfmRegisterProc (pMod, "ExceptionHandler", 1, (IfmProc)ExceptionHandler);
[!endif]
[!if CallBack_OnInitModule]
  IfmRegisterProc (pMod, "OnInitModule", 1, (IfmProc)OnInitModule);
[!endif]
[!if CallBack_OnExitModule]
  IfmRegisterProc (pMod, "OnExitModule", 1, (IfmProc)OnExitModule);
[!endif]
[!if CallBack_OnBeginDocument]
  IfmRegisterProc (pMod, "OnBeginDocument", 1, (IfmProc)OnBeginDocument);
[!endif]
[!if CallBack_OnEndDocument]
  IfmRegisterProc (pMod, "OnEndDocument", 1, (IfmProc)OnEndDocument);
[!endif]
[!if CallBack_Serialize]
  IfmRegisterProc (pMod, "Serialize", 1, (IfmProc)Serialize);
[!endif]
[!if CallBack_OnActivate]
  IfmRegisterProc (pMod, "OnActivate", 1, (IfmProc)OnActivate);
[!endif]
[!if CallBack_OnEditDocument]
  IfmRegisterProc (pMod, "OnEditDocument", 1, (IfmProc)OnEditDocument);
[!endif]
[!if CallBack_OnEnterProblemEditor]
  IfmRegisterProc (pMod, "OnEnterProblemEditor", 1, (IfmProc)OnEnterProblemEditor);
[!endif]
[!if CallBack_OnLeaveProblemEditor]
  IfmRegisterProc (pMod, "OnLeaveProblemEditor", 1, (IfmProc)OnLeaveProblemEditor);
[!endif]
[!if CallBack_OnEnterSimulator]
  IfmRegisterProc (pMod, "OnEnterSimulator", 1, (IfmProc)OnEnterSimulator);
[!endif]
[!if CallBack_OnLeaveSimulator]
  IfmRegisterProc (pMod, "OnLeaveSimulator", 1, (IfmProc)OnLeaveSimulator);
[!endif]
[!if CallBack_PreSimulation]
  IfmRegisterProc (pMod, "PreSimulation", 1, (IfmProc)PreSimulation);
[!endif]
[!if CallBack_PostSimulation]
  IfmRegisterProc (pMod, "PostSimulation", 1, (IfmProc)PostSimulation);
[!endif]
[!if CallBack_PreTimeStep]
  IfmRegisterProc (pMod, "PreTimeStep", 1, (IfmProc)PreTimeStep);
[!endif]
[!if CallBack_PostTimeStep]
  IfmRegisterProc (pMod, "PostTimeStep", 1, (IfmProc)PostTimeStep);
[!endif]
[!if CallBack_OnTimeStepConstraint]
  IfmRegisterProc (pMod, "OnTimeStepConstraint", 1, (IfmProc)OnTimeStepConstraint);
[!endif]
[!if CallBack_PreFlowSimulation]
  IfmRegisterProc (pMod, "PreFlowSimulation", 1, (IfmProc)PreFlowSimulation);
[!endif]
[!if CallBack_PostFlowSimulation]
  IfmRegisterProc (pMod, "PostFlowSimulation", 1, (IfmProc)PostFlowSimulation);
[!endif]
[!if CallBack_PreMassSimulation]
  IfmRegisterProc (pMod, "PreMassSimulation", 1, (IfmProc)PreMassSimulation);
[!endif]
[!if CallBack_PostMassSimulation]
  IfmRegisterProc (pMod, "PostMassSimulation", 1, (IfmProc)PostMassSimulation);
[!endif]
[!if CallBack_PreHeatSimulation]
  IfmRegisterProc (pMod, "PreHeatSimulation", 1, (IfmProc)PreHeatSimulation);
[!endif]
[!if CallBack_PostHeatSimulation]
  IfmRegisterProc (pMod, "PostHeatSimulation", 1, (IfmProc)PostHeatSimulation);
[!endif]
[!if CallBack_PreSaveDocument]
  IfmRegisterProc (pMod, "PreSaveDocument", 1, (IfmProc)PreSaveDocument);
[!endif]
[!if CallBack_PostSaveDocument]
  IfmRegisterProc (pMod, "PostSaveDocument", 1, (IfmProc)PostSaveDocument);
[!endif]
[!if CallBack_PostLoadDocument]
  IfmRegisterProc (pMod, "PostLoadDocument", 1, (IfmProc)PostLoadDocument);
[!endif]
[!if CallBack_OnChangeProblemClass]
  IfmRegisterProc (pMod, "OnChangeProblemClass", 1, (IfmProc)OnChangeProblemClass);
[!endif]
[!if CallBack_OnChangeTopology]
  IfmRegisterProc (pMod, "OnChangeTopology", 1, (IfmProc)OnChangeTopology);
[!endif]
[!if CallBack_OnLockPowerID]
  IfmRegisterProc (pMod, "OnLockPowerID", 1, (IfmProc)OnLockPowerID);
[!endif]
[!if CallBack_OnMarkElementsForAMR]
  IfmRegisterProc (pMod, "OnMarkElementsForAMR", 1, (IfmProc)OnMarkElementsForAMR);
[!endif]
[!if CallBack_OnRefineElementAttributes]
  IfmRegisterProc (pMod, "OnRefineElementAttributes", 1, (IfmProc)OnRefineElementAttributes);
[!endif]
[!if CallBack_OnRefineNodeAttributes]
  IfmRegisterProc (pMod, "OnRefineNodeAttributes", 1, (IfmProc)OnRefineNodeAttributes);
[!endif]
[!if CallBack_OnStateChanged]
  IfmRegisterProc (pMod, "OnStateChanged", 1, (IfmProc)OnStateChanged);
[!endif]
[!if CallBack_OnStateChanging]
  IfmRegisterProc (pMod, "OnStateChanging", 1, (IfmProc)OnStateChanging);
[!endif]
[!if CallBack_PostRefineProblem]
  IfmRegisterProc (pMod, "PostRefineProblem", 1, (IfmProc)PostRefineProblem);
[!endif]
[!if CallBack_PreRefineProblem]
  IfmRegisterProc (pMod, "PreRefineProblem", 1, (IfmProc)PreRefineProblem);
[!endif]
  return True;
}

[!if CallBack_Serialize]
static void Serialize (IfmDocument pDoc, IfmArchive pArc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->Serialize (pDoc, pArc);
}
[!endif]
[!if CallBack_PostLoadDocument]
static void PostLoadDocument (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PostLoadDocument (pDoc);
}
[!endif]
[!if CallBack_PreSaveDocument]
static void PreSaveDocument (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PreSaveDocument (pDoc);
}
[!endif]
[!if CallBack_PostSaveDocument]
static void PostSaveDocument (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PostSaveDocument (pDoc);
}
[!endif]
[!if CallBack_OnActivate]
static void OnActivate (IfmDocument pDoc, Widget button)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnActivate (pDoc, button);
}
[!endif]
[!if CallBack_OnEditDocument]
static void OnEditDocument (IfmDocument pDoc, Widget wParent)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnEditDocument (pDoc, wParent);
}
[!endif]
[!if CallBack_OnEnterProblemEditor]
static void OnEnterProblemEditor (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnEnterProblemEditor (pDoc);
}
[!endif]
[!if CallBack_OnLeaveProblemEditor]
static void OnLeaveProblemEditor (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnLeaveProblemEditor (pDoc);
}
[!endif]
[!if CallBack_OnEnterSimulator]
static void OnEnterSimulator (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnEnterSimulator (pDoc);
}
[!endif]
[!if CallBack_OnLeaveSimulator]
static void OnLeaveSimulator (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnLeaveSimulator (pDoc);
}
[!endif]
[!if CallBack_PreSimulation]
static void PreSimulation (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PreSimulation (pDoc);
}
[!endif]
[!if CallBack_PostSimulation]
static void PostSimulation (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PostSimulation (pDoc);
}
[!endif]
[!if CallBack_PreTimeStep]
static void PreTimeStep (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PreTimeStep (pDoc);
}
[!endif]
[!if CallBack_PostTimeStep]
static void PostTimeStep (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PostTimeStep (pDoc);
}
[!endif]
[!if CallBack_OnTimeStepConstraint]
static IfmBool OnTimeStepConstraint (IfmDocument pDoc, double tNow, double* dtProposed)
{
  return [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnTimeStepConstraint (pDoc, tNow, dtProposed);
}
[!endif]
[!if CallBack_PreFlowSimulation]
static void PreFlowSimulation (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PreFlowSimulation (pDoc);
}
[!endif]
[!if CallBack_PostFlowSimulation]
static void PostFlowSimulation (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PostFlowSimulation (pDoc);
}
[!endif]
[!if CallBack_PreMassSimulation]
static void PreMassSimulation (IfmDocument pDoc, int iSpecies)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PreMassSimulation (pDoc, iSpecies);
}
[!endif]
[!if CallBack_PostMassSimulation]
static void PostMassSimulation (IfmDocument pDoc, int iSpecies)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PostMassSimulation (pDoc, iSpecies);
}
[!endif]
[!if CallBack_PreHeatSimulation]
static void PreHeatSimulation (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PreHeatSimulation (pDoc);
}
[!endif]
[!if CallBack_PostHeatSimulation]
static void PostHeatSimulation (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PostHeatSimulation (pDoc);
}
[!endif]
[!if CallBack_OnChangeProblemClass]
static IfmResult OnChangeProblemClass (IfmDocument pDoc)
{
  return [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnChangeProblemClass (pDoc);
}
[!endif]
[!if CallBack_OnChangeTopology]
static void OnChangeTopology (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnChangeTopology (pDoc);
}
[!endif]
[!if CallBack_OnLockPowerID]
static IfmBool OnLockPowerID (IfmDocument pDoc, int nPowerID)
{
  return [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnLockPowerID (pDoc, nPowerID);
}
[!endif]
[!if CallBack_OnMarkElementsForAMR]
static void OnMarkElementsForAMR (IfmDocument pDoc)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnMarkElementsForAMR (pDoc);
}
[!endif]
[!if CallBack_PreRefineProblem]
static IfmResult PreRefineProblem (IfmDocument pDoc, int nNodeCount2D, int nElemCount2D)
{
  return [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PreRefineProblem (pDoc, nNodeCount2D, nElemCount2D);
}
[!endif]
[!if CallBack_PostRefineProblem]
static void PostRefineProblem (IfmDocument pDoc, IfmBool bDiscard)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->PostRefineProblem (pDoc, bDiscard);
}
[!endif]
[!if CallBack_OnRefineElementAttributes]
static void OnRefineElementAttributes (IfmDocument pDoc, int nNewCount, int* pNewElem, 
				       int nOldCount, int* pOldElem)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnRefineElementAttributes (pDoc, nNewCount, pNewElem, nOldCount, pOldElem);
}
[!endif]
[!if CallBack_OnRefineNodeAttributes]
static void OnRefineNodeAttributes (IfmDocument pDoc, 
				    int nNewNode, int nNodeFrom, int nNodeTo)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnRefineNodeAttributes (pDoc, nNewNode, nNodeFrom, nNodeTo);
}
[!endif]
[!if CallBack_OnStateChanging]
static IfmBool OnStateChanging (IfmDocument pDoc, IfmDOC_STATE newState)
{
  return [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnStateChanging (pDoc, newState);
}
[!endif]
[!if CallBack_OnStateChanged]
static void OnStateChanged (IfmDocument pDoc, IfmDOC_STATE newState)
{
  [!output MODULE_CLASSNAME]::FromHandle(pDoc)->OnStateChanged (pDoc, newState);
}
[!endif]

/* --- IFMREG_END --- */
#pragma endregion


[!if CallBack_ExceptionHandler]
static void ExceptionHandler (IfmHandle pHdl, IfmExceptionContext* pEx)
{								     
  /* 
   * TODO: If you want to suppress the warning message in FEFLOW's LOG window
   *	   the next two lines must be commented out!
   */
  IfmWarning (pHdl, "%s: %s! Skipped...\n", pEx->proc, pEx->reason);

  /* 
   * TODO: 
   *  If you want to abort the simulation step you can use the action:
   *
      pEx->action = IfmEX_ABORT;
   */

  /*
   * TODO:
   *  If you want to ignore the exception condition
   *  you can use the following construction:
   *  (Which member of argUnion takes affect depends on argType)
   *
      pEx->argUnion.aDouble = 0.; 
      pEx->action = IfmEX_CONTINUE;
   *
   */
}
  
[!endif]
[!if CallBack_OnInitModule]
static IfmResult OnInitModule (IfmHandle pHdl)
{
  /*
   * TODO: Add your own initialization code here ...
   */
  return True;
}

[!endif]
[!if CallBack_OnExitModule]
static void OnExitModule (IfmHandle pHdl)
{
  /*
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnBeginDocument]
static IfmResult OnBeginDocument (IfmDocument pDoc)
{
  if (IfmDocumentVersion (pDoc) < IFM_CURRENT_DOCUMENT_VERSION)
    return false;

  try {
    IfmDocumentSetUserData(pDoc, new [!output MODULE_CLASSNAME](pDoc));
  }
  catch (...) {
    return false;
  }

  return true;
}

[!endif]
[!if CallBack_OnEndDocument]
static void OnEndDocument (IfmDocument pDoc)
{
  delete [!output MODULE_CLASSNAME]::FromHandle(pDoc);
}

[!endif]
///////////////////////////////////////////////////////////////////////////
// Implementation of [!output MODULE_CLASSNAME]

// Constructor
[!output MODULE_CLASSNAME]::[!output MODULE_CLASSNAME] (IfmDocument pDoc)
  : m_pDoc(pDoc)
{
  /*
   * TODO: Add your own code here ...
   */
}

// Destructor
[!output MODULE_CLASSNAME]::~[!output MODULE_CLASSNAME] ()
{
  /*
   * TODO: Add your own code here ...
   */
}

// Obtaining class instance from document handle
[!output MODULE_CLASSNAME]* [!output MODULE_CLASSNAME]::FromHandle (IfmDocument pDoc)
{
  return reinterpret_cast<[!output MODULE_CLASSNAME]*>(IfmDocumentGetUserData(pDoc));
}

// Callbacks
[!if CallBack_Serialize]
void [!output MODULE_CLASSNAME]::Serialize (IfmDocument pDoc, IfmArchive pArc)
{
  /*
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PostLoadDocument]
void [!output MODULE_CLASSNAME]::PostLoadDocument (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PreSaveDocument]
void [!output MODULE_CLASSNAME]::PreSaveDocument (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PostSaveDocument]
void [!output MODULE_CLASSNAME]::PostSaveDocument (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnActivate]
void [!output MODULE_CLASSNAME]::OnActivate (IfmDocument pDoc, Widget button)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnEditDocument]
void [!output MODULE_CLASSNAME]::OnEditDocument (IfmDocument pDoc, Widget wParent)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnEnterProblemEditor]
void [!output MODULE_CLASSNAME]::OnEnterProblemEditor (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnLeaveProblemEditor]
void [!output MODULE_CLASSNAME]::OnLeaveProblemEditor (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnEnterSimulator]
void [!output MODULE_CLASSNAME]::OnEnterSimulator (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnLeaveSimulator]
void [!output MODULE_CLASSNAME]::OnLeaveSimulator (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PreSimulation]
void [!output MODULE_CLASSNAME]::PreSimulation (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PostSimulation]
void [!output MODULE_CLASSNAME]::PostSimulation (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PreTimeStep]

void [!output MODULE_CLASSNAME]::PreTimeStep (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}
[!endif]
[!if CallBack_PostTimeStep]
void [!output MODULE_CLASSNAME]::PostTimeStep (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnTimeStepConstraint]
IfmBool [!output MODULE_CLASSNAME]::OnTimeStepConstraint (IfmDocument pDoc, double tNow, double* dtProposed)
{
  /* 
   * TODO: Add your own code here ...
   */
  return true;
}

[!endif]
[!if CallBack_PreFlowSimulation]
void [!output MODULE_CLASSNAME]::PreFlowSimulation (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PostFlowSimulation]
void [!output MODULE_CLASSNAME]::PostFlowSimulation (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PreMassSimulation]
void [!output MODULE_CLASSNAME]::PreMassSimulation (IfmDocument pDoc, int iSpecies)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PostMassSimulation]
void [!output MODULE_CLASSNAME]::PostMassSimulation (IfmDocument pDoc, int iSpecies)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PreHeatSimulation]
void [!output MODULE_CLASSNAME]::PreHeatSimulation (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_PostHeatSimulation]
void [!output MODULE_CLASSNAME]::PostHeatSimulation (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnChangeProblemClass]
IfmResult [!output MODULE_CLASSNAME]::OnChangeProblemClass (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
  return true;
}

[!endif]
[!if CallBack_OnChangeTopology]
void [!output MODULE_CLASSNAME]::OnChangeTopology (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnLockPowerID]
IfmBool [!output MODULE_CLASSNAME]::OnLockPowerID (IfmDocument pDoc, int nPowerID)
{
  /* 
   * TODO: Add your own code here ...
   */
  return false;
}

[!endif]
[!if CallBack_OnMarkElementsForAMR]
void [!output MODULE_CLASSNAME]::OnMarkElementsForAMR (IfmDocument pDoc)
{
  /* 
   * TODO: Add your own code here ...
   *    Call IfmSetAmrElementRefinement(pAmr, nIndex, IfmAMR_REFINE) 
   *    to mark the nIndex'th element for refining. 
   *	Similarly, you can use the flags IfmAMR_DEREFINE for derefining
   *	and IfmAMR_KEEP for unmarking.
   */
}

[!endif]
[!if CallBack_PreRefineProblem]
IfmResult [!output MODULE_CLASSNAME]::PreRefineProblem (IfmDocument pDoc, int nNodeCount2D, int nElemCount2D)
{
  /* 
   * TODO: Add your own code here ...
   */
  return true;
}

[!endif]
[!if CallBack_PostRefineProblem]
void [!output MODULE_CLASSNAME]::PostRefineProblem (IfmDocument pDoc, IfmBool bDiscard)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnRefineElementAttributes]
void [!output MODULE_CLASSNAME]::OnRefineElementAttributes (IfmDocument pDoc, int nNewCount, int* pNewElem, int nOldCount, int* pOldElem)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnRefineNodeAttributes]
void [!output MODULE_CLASSNAME]::OnRefineNodeAttributes (IfmDocument pDoc, int nNewNode, int nNodeFrom, int nNodeTo)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
[!if CallBack_OnStateChanging]
IfmBool [!output MODULE_CLASSNAME]::OnStateChanging (IfmDocument pDoc, IfmDOC_STATE newState)
{
  /* 
   * TODO: Add your own code here ...
   */
  return true;
}

[!endif]
[!if CallBack_OnStateChanged]
void [!output MODULE_CLASSNAME]::OnStateChanged (IfmDocument pDoc, IfmDOC_STATE newState)
{
  /* 
   * TODO: Add your own code here ...
   */
}

[!endif]
