#pragma once

// Plugin implementation class
class [!output MODULE_CLASSNAME]
{
public:
  [!output MODULE_CLASSNAME](IfmDocument pDoc);
  ~[!output MODULE_CLASSNAME]();
  static [!output MODULE_CLASSNAME]* FromHandle(IfmDocument pDoc);

#pragma region IFM_Definitions
  // Implementation
public:
[!if CallBack_Serialize]
  void Serialize (IfmDocument pDoc, IfmArchive pArc);
[!endif]
[!if CallBack_OnActivate]
  void OnActivate (IfmDocument pDoc, Widget wParent);
[!endif]
[!if CallBack_OnEditDocument]
  void OnEditDocument (IfmDocument pDoc, Widget wParent);
[!endif]
[!if CallBack_OnEnterSimulator]
  void OnEnterSimulator (IfmDocument pDoc);
[!endif]
[!if CallBack_OnLeaveSimulator]
  void OnLeaveSimulator (IfmDocument pDoc);
[!endif]
[!if CallBack_OnEnterProblemEditor]
  void OnEnterProblemEditor (IfmDocument pDoc);
[!endif]
[!if CallBack_OnLeaveProblemEditor]
  void OnLeaveProblemEditor (IfmDocument pDoc);
[!endif]
[!if CallBack_PreSimulation]
  void PreSimulation (IfmDocument pDoc);
[!endif]
[!if CallBack_PostSimulation]
  void PostSimulation (IfmDocument pDoc);
[!endif]
[!if CallBack_PreTimeStep]
  void PreTimeStep (IfmDocument pDoc);
[!endif]
[!if CallBack_PostTimeStep]
  void PostTimeStep (IfmDocument pDoc);
[!endif]
[!if CallBack_PreFlowSimulation]
  void PreFlowSimulation (IfmDocument pDoc);
[!endif]
[!if CallBack_PostFlowSimulation]
  void PostFlowSimulation (IfmDocument pDoc);
[!endif]
[!if CallBack_PreMassSimulation]
  void PreMassSimulation (IfmDocument pDoc, int iSpecies);
[!endif]
[!if CallBack_PostMassSimulation]
  void PostMassSimulation (IfmDocument pDoc, int iSpecies);
[!endif]
[!if CallBack_PreHeatSimulation]
  void PreHeatSimulation (IfmDocument pDoc);
[!endif]
[!if CallBack_PostHeatSimulation]
  void PostHeatSimulation (IfmDocument pDoc);
[!endif]
[!if CallBack_OnTimeStepConstraint]
  IfmBool OnTimeStepConstraint (IfmDocument pDoc, double tNow, double* dtProposed);
[!endif]
[!if CallBack_PostLoadDocument]
  void PostLoadDocument (IfmDocument pDoc);
[!endif]
[!if CallBack_PreSaveDocument]
  void PreSaveDocument (IfmDocument pDoc);
[!endif]
[!if CallBack_PostSaveDocument]
  void PostSaveDocument (IfmDocument pDoc);
[!endif]
[!if CallBack_OnChangeProblemClass]
  IfmResult OnChangeProblemClass (IfmDocument pDoc);
[!endif]
[!if CallBack_OnChangeTopology]
  void OnChangeTopology (IfmDocument pDoc);
[!endif]
[!if CallBack_OnLockPowerID]
  IfmBool OnLockPowerID (IfmDocument pDoc, int nID);
[!endif]
[!if CallBack_PreRefineProblem]
  IfmResult PreRefineProblem (IfmDocument pDoc, int, int);
[!endif]
[!if CallBack_PostRefineProblem]
  void PostRefineProblem (IfmDocument pDoc, IfmBool);
[!endif]
[!if CallBack_OnMarkElementsForAMR]
  void OnMarkElementsForAMR (IfmDocument pDoc);
[!endif]
[!if CallBack_OnRefineElementAttributes]
  void OnRefineElementAttributes (IfmDocument pDoc, int, int*, int, int*);
[!endif]
[!if CallBack_OnRefineNodeAttributes]
  void OnRefineNodeAttributes (IfmDocument pDoc, int, int, int);
[!endif]
[!if CallBack_OnStateChanged]
  void OnStateChanged (IfmDocument pDoc, IfmDOC_STATE);
[!endif]
[!if CallBack_OnStateChanging]
  IfmBool OnStateChanging (IfmDocument pDoc, IfmDOC_STATE);
[!endif]
#pragma endregion

private:
  IfmDocument m_pDoc;
};
